<template>
  <el-button
    v-if="show && site!=='tools'"
    :icon="myIcon"
    :loading="loading"
    :plain="myPlain"
    :size="mySize"
    :disabled="disabled"
    :type="myType"
    @click="click"
  >{{ myName }}
  </el-button>
  <el-button
    v-else-if="show && site==='tools'"
    :icon="myIcon"
    :loading="loading"
    :plain="myPlain"
    :size="mySize"
    :type="myType"
    @click="click"
  >{{ myName }}
  </el-button>
</template>
<script>
export default {
  props: {
    checkPermission: { // 按钮权限
      type: String,
      default: ''
    },
    site: { // filter 搜索条，tools 工具条，operation 操作栏，form 表单
      type: String,
      default: ''
    },
    type: {// 按钮类型
      type: String,
      default: ''
    },
    name: {// 按钮名称
      type: String,
      default: ''
    },
    icon: {// 图标
      type: String,
      default: null
    },
    size: {// 尺寸
      type: String,
      default: 'mini'
    },
    plain: {// 图标
      type: Boolean,
      default: false
    },
    disabled: {// 图标
      type: Boolean,
      default: false
    }
  },
  data() {
    return {
      filter: {// 搜索条上的按钮名称集合
        size: 'mini',
        plain: false,
        other: {
          '搜索': {
            type: 'primary',
            icon: 'el-icon-search'
          },
          '重置': {
            type: 'warning',
            icon: 'el-icon-refresh'
          },
          '导出': {
            type: 'info'
          }

        }
      },
      tools: {// 工具条上的按钮集合
        size: 'medium',
        plain: true,
        type: 'primary',
        other: {
          '添加': {
            icon: 'el-icon-plus'
          },
          '返回': {
            icon: 'el-icon-edit-outline'
          },
          '查看': {
            icon: 'el-icon-refresh'
          },
          '导入': {
            icon: 'el-icon-upload2'
          },
          '导入模板下载': {
            icon: 'el-icon-download'
          },
          '导出': {
            icon: 'el-icon-download'
          },
          '打印': {
            icon: 'el-icon-printer'
          },
          '导出EXCEL': {
            icon: 'el-icon-download'
          },
          '导出EXCEL(不分页)': {
            icon: 'el-icon-download'
          },
          '导出EXCEL(分页)': {
            icon: 'el-icon-download'
          },
          '导出WORD': {
            icon: 'el-icon-download'
          },
          '导出PDF': {
            icon: 'el-icon-download'
          },
          '机构导入': {
            icon: 'el-icon-edit-outline'
          },
          '导入记录': {
            icon: 'el-icon-edit-outline'
          },
          '导入记录查询': {
            icon: 'el-icon-refresh'
          },
          '新增': {
            icon: 'el-icon-edit-outline'
          },
          '维护指标': {
            icon: 'el-icon-refresh'
          }
        }
      },
      form: { // 表单上的按钮
        size: 'medium',
        plain: false,
        other: {
          '选择': {
            type: 'primary'
          },
          '服务人员': {
            type: 'primary'
          },
          '保存': {
            type: 'primary'
          },
          '保存并发布': {
            type: 'success'
          },
          '取消': {
            type: 'default'
          },
          '返回': {
            type: 'default'
          },
          '关闭': {
            type: 'default'
          },
          '重置': {
            type: 'default'
          },
          '暂存': {
            type: 'warning'
          },
          '查询': {
            type: 'primary'
          },
          '确认': {
            type: 'primary'
          },
          '确定': {
            type: 'primary'
          },
          '地址拾取': {
            type: 'primary'
          },
          '下载图片': {
            type: 'success'
          },
          '提交': {
            type: 'primary'
          },
          '转派': {
            type: 'success'
          },
          '处理': {
            type: 'primary'
          },
          '上报': {
            type: 'primary'
          }
        }
      },
      operation: {// 操作栏上的按钮集合
        size: 'mini',
        plain: true,
        other: {
          '填入': {
            type: 'primary'
          },
          '人员配置': {
            type: 'primary'
          },
          '模板预览': {
            type: 'success'
          },
          '调查项配置': {
            type: 'default'
          },
          '等级协议': {
            type: 'primary'
          },
          '查看详情': {
            type: 'default'
          },
          '编辑': {
            type: 'primary'
          },
          '下载': {
            type: 'primary'
          },
          '添加': {
            type: 'primary'
          },
          '处理': {
            type: 'primary'
          },
          '删除': {
            type: 'danger'
          },
          '关闭': {
            type: 'danger'
          },
          '返回': {
            type: 'danger'
          },
          '权限': {
            type: 'success'
          },
          '角色': {
            type: 'warning'
          },
          '密码初始化': {
            type: 'default'
          },
          '重置密码': {
            type: 'warning'
          },
          '人员': {
            type: 'success'
          },
          '备注': {
            type: 'warning'
          },
          '启用': {
            type: 'success'
          },
          '禁用': {
            type: 'warning'
          },
          '启用黑名单': {
            type: 'success'
          },
          '加入黑名单': {
            type: 'danger'
          },
          '审核': {
            type: 'primary'
          },
          '撤回': {
            type: 'danger'
          },
          '详情': {
            type: 'success'
          },
          '提交': {
            type: 'warning'
          },
          '修改': {
            type: 'warning'
          },
          '取消': {
            type: 'default'
          },
          '还原': {
            type: 'warning'
          },
          '归档': {
            type: 'primary'
          },
          '调查详情': {
            type: 'primary'
          },
          '预览': {
            type: 'success'
          },
          '复制': {
            type: 'default'
          },
          '工单详情': {
            type: 'success'
          }
        }
      },
      text: { // 表单上的按钮
        size: 'mini',
        type: 'text',
        icon: '',
        other: {
          '添加': {
            type: 'primary'
          },
          '确定': {
            type: 'primary'
          }
        }
      },
      loading: false,
      myType: this.type, // 按钮类型
      myName: this.name, // 按钮名称
      myIcon: this.icon, // 按钮图标
      mySize: this.size, // 按钮大小
      myPlain: this.plain, // 是否朴素按钮
      show: true // 是否显示
    }
  },
  created() {
    if (this.checkPermission != '' && this.$store.getters.myButtonPermission.indexOf(this.checkPermission) < 0) {
      this.show = false
      return
    }
    this.myName = this.name
    if (this.site == 'filter') {
      this.mySize = this.filter.size
      this.myPlain = this.filter.plain
      this.myType = this.type || this.filter.other[this.myName].type
      this.myIcon = this.icon || this.filter.other[this.myName].icon
    } else if (this.site == 'tools') {
      this.mySize = this.tools.size
      this.myPlain = this.tools.plain
      this.myType = this.tools.type
      if (this.icons != null) {
        this.myIcon = this.icons
      } else {
        this.myIcon = this.tools.other[this.myName].icon
      }
    } else if (this.site == 'operation') {
      this.mySize = this.operation.size
      this.myPlain = this.operation.plain
      this.myType = this.type || this.operation.other[this.myName].type
    } else if (this.site == 'form') {
      this.mySize = this.form.size || this.size
      this.myPlain = this.form.plain
      this.myType = this.type || this.form.other[this.myName].type
    } else if (this.site == 'text') {
      this.mySize = this.text.size
      this.myType = this.text.type
      this.myIcon = this.icon || this.text.other[this.myName].icon
    } else {
      this.mySize = 'mini'
      this.myPlain = false
      this.myType = 'text'
    }
  },
  methods: {
    click() {
      if (this.site == 'form') {
        this.loading = true
      }
      this.$emit('click')
      setTimeout(() => {
        this.loading = false
      }, 3000)// 3秒内不能重复点击
    }
  }
}
</script>
